heuristika <- function (n,t,r=NULL,d=NULL,type,start=FALSE){
  if(is.null(r)){
    for(i in 1:length(t)){
      r[i]=0
    }
  }
  if(type == "LPT"){
    heur2 <- function(n,t,r,d,type)
    {
      if(type == "LPT")
      {
        m<-length(t)
        maxs=c()
        ind=c()
        for (i in 1:m){
          biggest=match(max(t), t)
          ind[i]=biggest
          maxs[i]=max(t)
          t[ind[i]]=0
        }
        return(ind)
      }
    }
    ind=heur2(n,t,r,d,"LPT")
    graf2<-function(ind,n,t)
    {
      datas2<-list()
      datas21<-list()
      for(k in 1:n)
      {
        datas2[k]=0
        datas21[k]=0
      }
      datas2[1][1]=t[ind[1]]
      for(i in 2:length(t)){
        stroj1=indexer(n, datas2)
        procesnumber=(length(datas2[[stroj1]])+1)
        if(datas2[[stroj1]][procesnumber-1]==0 )
          procesnumber=procesnumber-1
        datas2[[stroj1]][procesnumber]=t[ind[i]]
        datas21[[stroj1]][procesnumber]=ind[i]
      }
      datas21[[1]][1]=ind[1]
      datas2=append(datas2,datas21)
      return(datas2)
    }
    indexer<- function(n, datas2){
      sumar1=9999999
      sumar=sum(datas2[[1]])
      stroj=1
      for(k in 1:n){
        sumar = sum(datas2[[k]])

        if(sumar1 > sumar){
          sumar1=sumar
          stroj=k
        }
      }
      return(stroj)
    }
    harmonogram = graf2(ind,n,t)
    longestprocess<-function(harmonogram){
      sumar1=0
      stroj=1
      for(i in 1:length(harmonogram)/2){
        sumar = sum(harmonogram[[i]])
        if(sumar1 < sumar){
          sumar1=sumar
          stroj=i
        }
        stroj=sum(harmonogram[[i]])
      }
      return(stroj)
    }
    gantt<-function(harmonogram,ind,t){
      counter=1
      tcopy=t
      tasks=c(1:length(ind))
      start.date  = c(1:length(ind))
      end.date    = c(1:length(ind))
      Stroj = c(1:length(ind))
      x<-length(harmonogram)/2
      for(i in 1:x){
        y=length(harmonogram[[i]])
        start.date=0
        for(j in 1:y){
          if(j==1){
            start.date[counter]=0
            end.date[counter]=harmonogram[[i]][j]
            Stroj[counter]=i
            tasks[counter]=harmonogram[[n+i]][j]
            counter = counter + 1
          }
          else{
            start.date[counter]=end.date[counter-1]
            end.date[counter]=end.date[counter-1]+harmonogram[[i]][j]
            Stroj[counter]=i
            tasks[counter]=harmonogram[[n+i]][j]
            counter=counter+1
          }
        }
      }
      start.date=0
      for(i in 2:length(ind)){
        start.date[i]=end.date[i-1]
        if(start.date[i-1] > start.date[i]){
          start.date[i-1]=0
        }
      }
      dfg <- data.frame(
        tasks        = factor(rev(tasks), levels = rev(tasks)),
        start.date  = rev(start.date),
        end.date    = rev(end.date),
        Stroj = as.factor(rev(Stroj))
      )
    }
    dfr=  as.data.frame(gantt(harmonogram,ind,t))
    mdfr <- melt(dfr,measure.vars = c("start.date", "end.date"))
    ndfr1 <- subset(mdfr, variable == 'start.date', select=c(value))
    ndfr2 <- subset(mdfr, variable == 'end.date', select=c(value))
    gg<-ggplot(mdfr, aes(value, Stroj, colour = tasks)) +
      geom_line(size = 10) +
      geom_point(aes(value), colour = "black", shape = "line", size=13)+
      geom_text(aes(x=(ndfr1+ndfr2)/2,y=Stroj,label=tasks),colour="black")+
      ylab("Stroj") +
      xlab("Cas") +
      scale_y_discrete() +
      theme_bw()
    return(list(g=gg,type="LPT",r=r,d=d,c=dfr$end.date,data.frame=dfr))
  }
  else if(type == "SPT"){
    heur2 <- function(n,t,r,d,type)
    {
      if(type == "SPT")
      {
        m<-length(t)
        mins=c()
        ind=c()
        for (i in 1:m){
          biggest=match(min(t), t)
          ind[i]=biggest
          mins[i]=min(t)
          t[ind[i]]=max(t+1)
        }
        return(ind)
      }
    }
    ind=heur2(n,t,r,d,"SPT")
    graf2<-function(ind,n,t)
    {
      datas2<-list()
      datas21<-list()
      for(k in 1:n)
      {
        datas2[k]=0
        datas21[k]=0
      }
      datas2[1][1]=t[ind[1]]
      for(i in 2:length(t)){
        stroj1=indexer(n, datas2)
        procesnumber=(length(datas2[[stroj1]])+1)
        if(datas2[[stroj1]][procesnumber-1]==0 )
          procesnumber=procesnumber-1
        datas2[[stroj1]][procesnumber]=t[ind[i]]
        datas21[[stroj1]][procesnumber]=ind[i]
      }
      datas21[[1]][1]=ind[1]
      datas2=append(datas2,datas21)
      return(datas2)
    }
    indexer<- function(n, datas2){
      sumar1=9999999
      sumar=sum(datas2[[1]])
      stroj=1
      for(k in 1:n){
        sumar = sum(datas2[[k]])

        if(sumar1 > sumar){
          sumar1=sumar
          stroj=k
        }
      }
      return(stroj)
    }
    harmonogram = graf2(ind,n,t)
    longestprocess<-function(harmonogram){
      sumar1=0
      stroj=1
      for(i in 1:length(harmonogram)/2){
        sumar = sum(harmonogram[[i]])
        if(sumar1 < sumar){
          sumar1=sumar
          stroj=i
        }
        stroj=sum(harmonogram[[i]])
      }
      return(stroj)
    }
    gantt<-function(harmonogram,ind,t){
      counter=1
      tcopy=t
      tasks=c(1:length(ind))
      start.date  = c(1:length(ind))
      end.date    = c(1:length(ind))
      Stroj = c(1:length(ind))
      x<-length(harmonogram)/2
      for(i in 1:x){
        y=length(harmonogram[[i]])
        start.date=0
        for(j in 1:y){
          if(j==1){
            start.date[counter]=0
            end.date[counter]=harmonogram[[i]][j]
            Stroj[counter]=i
            tasks[counter]=harmonogram[[n+i]][j]
            counter = counter + 1
          }
          else{
            start.date[counter]=end.date[counter-1]
            end.date[counter]=end.date[counter-1]+harmonogram[[i]][j]
            Stroj[counter]=i
            tasks[counter]=harmonogram[[n+i]][j]
            counter=counter+1
          }
        }
      }
      start.date=0
      for(i in 2:length(ind)){
        start.date[i]=end.date[i-1]
        if(start.date[i-1] > start.date[i]){
          start.date[i-1]=0
        }
      }
      dfg <- data.frame(
        tasks        = factor(rev(tasks), levels = rev(tasks)),
        start.date  = rev(start.date),
        end.date    = rev(end.date),
        Stroj = as.factor(rev(Stroj))
      )
      return(dfg)
    }
    dfr=  as.data.frame(gantt(harmonogram,ind,t))
    mdfr <- melt(dfr, measure.vars = c("start.date", "end.date"))
    ndfr1 <- subset(mdfr, variable == 'start.date', select=c(value))
    ndfr2 <- subset(mdfr, variable == 'end.date', select=c(value))
    gg<-ggplot(mdfr, aes(value, Stroj, colour = tasks)) +
      geom_line(size = 10) +
      geom_point(aes(value), colour = "black", shape = "line", size=13)+
      geom_text(aes(x=(ndfr1+ndfr2)/2,y=Stroj,label=tasks),colour="black")+
      ylab("Stroj") +
      xlab("Cas") +
      theme_bw()+
      scale_y_discrete()
    return(list(g=gg,type="SPT",r=r,d=d,c=dfr$end.date,data.frame=dfr))
  }
  else if(type == "EST"){
    if(length(t)==length(r)){
      if(start==TRUE){
        heur2 <- function(n,t,r,d,type)
        {
          if(type == "EST"){
            m<-length(r)
            mins=c()
            ind=c()
            for (i in 1:m){
              biggest=match(min(r), r)
              ind[i]=biggest
              mins[i]=min(r)
              r[ind[i]]=max(r+1)
            }
            return(ind)
          }
        }
        ind=heur2(n,t,r,d,"EST")
        graf22<-function(ind,n,t,r)
        {
          datas2<-list() #zaciatok + TRVANIA
          datas22<-list()#index
          for(k in 1:n)
          {
            datas2[k]=0
            datas22[k]=0
          }
          datas2[[1]][1] =r[ind[1]]
          datas2[[1]][2] = t[ind[1]]+datas2[[1]][1]
          datas22[1][1]=ind[1]
          for(i in 2:length(t)){
            stroj1=indexer(n, datas2)
            procesnumber=(length(datas2[[stroj1]]))
            if(procesnumber == 1){
              datas2[[stroj1]][1] = r[ind[i]]
              datas2[[stroj1]][2] = t[ind[i]]+r[ind[i]]
            }
            else  if(datas2[[stroj1]][procesnumber]>r[ind[i]]){
              datas2[[stroj1]][procesnumber+1]=datas2[[stroj1]][procesnumber]
              datas2[[stroj1]][procesnumber+2]=datas2[[stroj1]][procesnumber+1]+t[ind[i]]
            }
            else{
              datas2[[stroj1]][procesnumber+1]=r[ind[i]]
              datas2[[stroj1]][procesnumber+2]=datas2[[stroj1]][procesnumber+1]+t[ind[i]]
            }
            if(procesnumber+1==1){
              datas22[[stroj1]][procesnumber+1]=ind[i]
            }
            else{
              datas22[[stroj1]][(procesnumber+2)/2]=ind[i]
            }
          }
          datas2=append(datas2,datas22)
          return(datas2)
        }
        indexer<- function(n, datas2){
          sumar1=9999999
          sumar=max(datas2[[1]])
          stroj=1
          for(k in 1:n){
            sumar = max(datas2[[k]])

            if(sumar1 > sumar){
              sumar1=sumar
              stroj=k
            }
          }
          return(stroj)
        }
        harmonogram = graf22(ind,n,t,r)
        gantt<-function(harmonogram,ind){
          counter=1
          tasks=c(1:length(ind))
          start.date  = c(1:length(ind))
          end.date    = c(1:length(ind))
          Stroj = c(1:length(ind))
          x<-length(harmonogram)/2
          for(i in 1:x){
            y=length(harmonogram[[i]])
            for(j in 1:y){
              if(j%%2==1){
                start.date[counter]=harmonogram[[i]][j]
                end.date[counter]=harmonogram[[i]][j+1]
                Stroj[counter]=i
                tasks[counter]=harmonogram[[x+i]][(j+1)/2]
                counter=counter+1
              }
            }
          }
          dfg <- data.frame(
            tasks        = factor(rev(tasks), levels = rev(tasks)),
            start.date  = rev(start.date),
            end.date    = rev(end.date),
            Stroj = as.factor(rev(Stroj))
          )
          return(dfg)
        }
        dfr=  as.data.frame(gantt(harmonogram,ind))
        mdfr <- melt(dfr, measure.vars = c("start.date", "end.date"))
        ndfr1 <- subset(mdfr, variable == 'start.date', select=c(value))
        ndfr2 <- subset(mdfr, variable == 'end.date', select=c(value))
        gg<-ggplot(mdfr, aes(value, Stroj, colour = tasks)) +
          geom_line(size = 10) +
          geom_point(aes(value), colour = "black", shape = "line", size=13)+
          geom_text(aes(x=(ndfr1+ndfr2)/2,y=Stroj,label=tasks),colour="black")+
          ylab("Stroj") +
          xlab("Cas") +
          theme_bw()+
          scale_y_discrete()
        return(list(g=gg,type="EST",start=TRUE,r=r,d=d,c=dfr$end.date,data.frame=dfr))
      }
      else{
        heur2 <- function(n,t,r,d,type)
        {
          if(type == "EST")
          {
            m<-length(r)
            mins=c()
            ind=c()
            for (i in 1:m){
              biggest=match(min(r), r)
              ind[i]=biggest
              mins[i]=min(r)
              r[ind[i]]=max(r+1)
            }
            return(ind)
          }
        }
        ind=heur2(n,t,r,d,"EST")
        graf2<-function(ind,n,t)
        {
          datas2<-list()
          datas21<-list()
          for(k in 1:n)
          {
            datas2[k]=0
            datas21[k]=0
          }
          datas2[1][1]=t[ind[1]]
          for(i in 2:length(t)){
            stroj1=indexer(n, datas2)
            procesnumber=(length(datas2[[stroj1]])+1)
            if(datas2[[stroj1]][procesnumber-1]==0 )
              procesnumber=procesnumber-1
            datas2[[stroj1]][procesnumber]=t[ind[i]]
            datas21[[stroj1]][procesnumber]=ind[i]
          }
          datas21[[1]][1]=ind[1]
          datas2=append(datas2,datas21)
          return(datas2)
        }
        indexer<- function(n, datas2){
          sumar1=9999999
          sumar=sum(datas2[[1]])
          stroj=1
          for(k in 1:n){
            sumar = sum(datas2[[k]])

            if(sumar1 > sumar){
              sumar1=sumar
              stroj=k
            }
          }
          return(stroj)
        }
        harmonogram = graf2(ind,n,t)
        longestprocess<-function(harmonogram){
          sumar1=0
          stroj=1
          for(i in 1:length(harmonogram)/2){
            sumar = sum(harmonogram[[i]])
            if(sumar1 < sumar){
              sumar1=sumar
              stroj=i
            }
            stroj=sum(harmonogram[[i]])
          }
          return(stroj)
        }
        gantt<-function(harmonogram,ind,t){
          counter=1
          tcopy=t
          tasks=c(1:length(ind))
          start.date  = c(1:length(ind))
          end.date    = c(1:length(ind))
          Stroj = c(1:length(ind))
          x<-length(harmonogram)/2
          for(i in 1:x){
            y=length(harmonogram[[i]])
            start.date=0
            for(j in 1:y){
              if(j==1){
                start.date[counter]=0
                end.date[counter]=harmonogram[[i]][j]
                Stroj[counter]=i
                tasks[counter]=harmonogram[[n+i]][j]
                counter = counter + 1
              }
              else{
                start.date[counter]=end.date[counter-1]
                end.date[counter]=end.date[counter-1]+harmonogram[[i]][j]
                Stroj[counter]=i
                tasks[counter]=harmonogram[[n+i]][j]
                counter=counter+1
              }
            }
          }
          start.date=0
          for(i in 2:length(ind)){
            start.date[i]=end.date[i-1]
            if(start.date[i-1] > start.date[i]){
              start.date[i-1]=0
            }
          }
          dfg <- data.frame(
            tasks        = factor(rev(tasks), levels = rev(tasks)),
            start.date  = rev(start.date),
            end.date    = rev(end.date),
            Stroj = as.factor(rev(Stroj))
          )
          return(dfg)
        }
        dfr=  as.data.frame(gantt(harmonogram,ind,t))
        mdfr <- melt(dfr, measure.vars = c("start.date", "end.date"))
        ndfr1 <- subset(mdfr, variable == 'start.date', select=c(value))
        ndfr2 <- subset(mdfr, variable == 'end.date', select=c(value))
        gg<-ggplot(mdfr, aes(value, Stroj, colour = tasks)) +
          geom_line(size = 10) +
          geom_point(aes(value), colour = "black", shape = "line", size=13)+
          geom_text(aes(x=(ndfr1+ndfr2)/2,y=Stroj,label=tasks),colour="black")+
          ylab("Stroj") +
          xlab("Cas") +
          theme_bw()+
          scale_y_discrete()
        return(list(g=gg,type="EST",start=FALSE,r=r,d=d,c=dfr$end.date,data.frame=dfr))
      }
    }
    else{
      print("Vectory t a r musia mat rovnaku dlzku")
    }
  }
  else if(type == "LST"){
    if(length(t)==length(r)){
      if(start==TRUE){
        heur2 <- function(n,t,r,d,type)
        {
          if(type == "LST"){
            m<-length(r)
            maxs=c()
            ind=c()
            for (i in 1:m){
              biggest=match(max(r), r)
              ind[i]=biggest
              maxs[i]=max(r)
              r[ind[i]]=0
            }
            return(ind)
          }
        }
        ind=heur2(n,t,r,d,"LST")
        graf22 <- function(ind,n,t,r)
        {
          datas2 <- list() #zaciatok + TRVANIA
          datas22 <- list()#index
          for (k in 1:n)
          {
            datas2[k] = 0
            datas22[k] = 0
          }
          datas2[[1]][1] = r[ind[1]]
          datas2[[1]][2] = t[ind[1]] + datas2[[1]][1]
          datas22[1][1] = ind[1]
          for(j in 1:n){
            datas2[[j]][1] = r[ind[j]]
            datas2[[j]][2] = t[ind[j]] + r[ind[j]]
            datas22[[j]][1]=ind[j]
          }
          for (i in (n+1):length(ind)) {
            end = r[ind[i]] + t[ind[i]]
            stroj1 = indexer(n, datas2,start,end)
            procesnumber = (length(datas2[[abs(stroj1)]]))
            if (stroj1 < 0) {
              datas2[[abs(stroj1)]][procesnumber + 1] = r[ind[i]]
              datas2[[abs(stroj1)]][procesnumber + 2] = t[ind[i]] + r[ind[i]]
            }
            else{
              datas2[[stroj1]][procesnumber + 1] = datas2[[stroj1]][procesnumber]
              datas2[[stroj1]][procesnumber + 2] = datas2[[stroj1]][procesnumber + 1] + t[ind[i]]
            }
            stroj1=abs(stroj1)
            if (procesnumber + 1 == 1) {
              datas22[[stroj1]][procesnumber + 1] = ind[i]
            }
            else{
              datas22[[stroj1]][(procesnumber + 2) / 2] = ind[i]
            }
          }
          datas2 = append(datas2,datas22)
          return(datas2)
        }
        indexer <- function(n, datas2,start,end) {
          stroj = 1
          ok = FALSE
          for (j in 1:length(datas2)) {
            if (end <= min(datas2[[j]])) {
              stroj = -j
              ok = TRUE
              break
            }
            if (ok == FALSE) {
              maximum = max(datas2[[1]])
              for (j in 1:length(datas2)) {
                sumar = max(datas2[[j]])

                if (maximum > sumar) {
                  maximum = sumar
                  stroj = j
                  break
                }
              }
            }
          }
          return(stroj)
        }
        harmonogram = graf22(ind,n,t,r)
        gantt<-function(harmonogram,ind){
          counter=1
          tasks=c(1:length(ind))
          start.date  = c(1:length(ind))
          end.date    = c(1:length(ind))
          Stroj = c(1:length(ind))
          x<-length(harmonogram)/2
          for(i in 1:x){
            y=length(harmonogram[[i]])
            for(j in 1:y){
              if(j%%2==1){
                start.date[counter]=harmonogram[[i]][j]
                end.date[counter]=harmonogram[[i]][j+1]
                Stroj[counter]=i
                tasks[counter]=harmonogram[[x+i]][(j+1)/2]
                counter=counter+1
              }
            }
          }
          dfg <- data.frame(
            tasks        = factor(rev(tasks), levels = rev(tasks)),
            start.date  = rev(start.date),
            end.date    = rev(end.date),
            Stroj = as.factor(rev(Stroj))
          )
          return(dfg)
        }
        dfr=  as.data.frame(gantt(harmonogram,ind))
        mdfr <- melt(dfr, measure.vars = c("start.date", "end.date"))
        ndfr1 <- subset(mdfr, variable == 'start.date', select=c(value))
        ndfr2 <- subset(mdfr, variable == 'end.date', select=c(value))
        gg<-ggplot(mdfr, aes(value, Stroj, colour = tasks)) +
          geom_line(size = 10) +
          geom_point(aes(value), colour = "black", shape = "line", size=13)+
          geom_text(aes(x=(ndfr1+ndfr2)/2,y=Stroj,label=tasks),colour="black")+
          ylab("Stroj") +
          xlab("Cas") +
          theme_bw()+
          scale_y_discrete()
        return(list(g=gg,type="LST",start=TRUE,r=r,d=d,c=dfr$end.date,data.frame=dfr))
      }
      else{
        heur2 <- function(n,t,r,d,type)
        {
          if(type == "LST"){
            m<-length(r)
            maxs=c()
            ind=c()
            for (i in 1:m){
              biggest=match(max(r), r)
              ind[i]=biggest
              maxs[i]=max(r)
              r[ind[i]]=0
            }
            return(ind)
          }
        }
        ind=heur2(n,t,r,d,"LST")
        graf2<-function(ind,n,t)
        {
          datas2<-list()
          datas21<-list()
          for(k in 1:n)
          {
            datas2[k]=0
            datas21[k]=0
          }
          datas2[1][1]=t[ind[1]]
          for(i in 2:length(t)){
            stroj1=indexer(n, datas2)
            procesnumber=(length(datas2[[stroj1]])+1)
            if(datas2[[stroj1]][procesnumber-1]==0 )
              procesnumber=procesnumber-1
            datas2[[stroj1]][procesnumber]=t[ind[i]]
            datas21[[stroj1]][procesnumber]=ind[i]
          }
          datas21[[1]][1]=ind[1]
          datas2=append(datas2,datas21)
          return(datas2)
        }
        indexer<- function(n, datas2){
          sumar1=9999999
          sumar=sum(datas2[[1]])
          stroj=1
          for(k in 1:n){
            sumar = sum(datas2[[k]])

            if(sumar1 > sumar){
              sumar1=sumar
              stroj=k
            }
          }
          return(stroj)
        }
        harmonogram = graf2(ind,n,t)
        longestprocess<-function(harmonogram){
          sumar1=0
          stroj=1
          for(i in 1:length(harmonogram)/2){
            sumar = sum(harmonogram[[i]])
            if(sumar1 < sumar){
              sumar1=sumar
              stroj=i
            }
            stroj=sum(harmonogram[[i]])
          }
          return(stroj)
        }
        gantt<-function(harmonogram,ind,t){
          counter=1
          tcopy=t
          tasks=c(1:length(ind))
          start.date  = c(1:length(ind))
          end.date    = c(1:length(ind))
          Stroj = c(1:length(ind))
          x<-length(harmonogram)/2
          for(i in 1:x){
            y=length(harmonogram[[i]])
            start.date=0
            for(j in 1:y){
              if(j==1){
                start.date[counter]=0
                end.date[counter]=harmonogram[[i]][j]
                Stroj[counter]=i
                tasks[counter]=harmonogram[[n+i]][j]
                counter = counter + 1
              }
              else{
                start.date[counter]=end.date[counter-1]
                end.date[counter]=end.date[counter-1]+harmonogram[[i]][j]
                Stroj[counter]=i
                tasks[counter]=harmonogram[[n+i]][j]
                counter=counter+1
              }
            }
          }
          start.date=0
          for(i in 2:length(ind)){
            start.date[i]=end.date[i-1]
            if(start.date[i-1] > start.date[i]){
              start.date[i-1]=0
            }
          }
          dfg <- data.frame(
            tasks        = factor(rev(tasks), levels = rev(tasks)),
            start.date  = rev(start.date),
            end.date    = rev(end.date),
            Stroj = as.factor(rev(Stroj))
          )
          return(dfg)
        }
        dfr=  as.data.frame(gantt(harmonogram,ind,t))
        mdfr <- melt(dfr, measure.vars = c("start.date", "end.date"))
        ndfr1 <- subset(mdfr, variable == 'start.date', select=c(value))
        ndfr2 <- subset(mdfr, variable == 'end.date', select=c(value))
        gg<-ggplot(mdfr, aes(value, Stroj, colour = tasks)) +
          geom_line(size = 10) +
          geom_point(aes(value), colour = "black", shape = "line", size=13)+
          geom_text(aes(x=(ndfr1+ndfr2)/2,y=Stroj,label=tasks),colour="black")+
          ylab("Stroj") +
          xlab("Cas") +
          theme_bw()+
          scale_y_discrete()
        return(list(g=gg,type="LST",start=FALSE,r=r,d=d,c=dfr$end.date,data.frame=dfr))
      }
    }
    else{
      print("Vectory t a r musia mat rovnaku dlzku")
    }
  }
  else if(type == "EFT"){
    if(length(t)==length(d)){
      heur2 <- function(n,t,r,d,type)
      {
        if(type == "EFT")
        {
          m<-length(d)
          mins=c()
          ind=c()
          for (i in 1:m){
            biggest=match(min(d), d)
            ind[i]=biggest
            mins[i]=min(d)
            d[ind[i]]=max(d+1)
          }
          return(ind)
        }
      }
      ind=heur2(n,t,r,d,"EFT")
      graf2<-function(ind,n,t)
      {
        datas2<-list()
        datas21<-list()
        for(k in 1:n)
        {
          datas2[k]=0
          datas21[k]=0
        }
        datas2[1][1]=t[ind[1]]
        for(i in 2:length(t)){
          stroj1=indexer(n, datas2)
          procesnumber=(length(datas2[[stroj1]])+1)
          if(datas2[[stroj1]][procesnumber-1]==0 )
            procesnumber=procesnumber-1
          datas2[[stroj1]][procesnumber]=t[ind[i]]
          datas21[[stroj1]][procesnumber]=ind[i]
        }
        datas21[[1]][1]=ind[1]
        datas2=append(datas2,datas21)
        return(datas2)
      }
      indexer<- function(n, datas2){
        sumar1=9999999
        sumar=sum(datas2[[1]])
        stroj=1
        for(k in 1:n){
          sumar = sum(datas2[[k]])

          if(sumar1 > sumar){
            sumar1=sumar
            stroj=k
          }
        }
        return(stroj)
      }
      harmonogram = graf2(ind,n,t)
      longestprocess<-function(harmonogram){
        sumar1=0
        stroj=1
        for(i in 1:length(harmonogram)/2){
          sumar = sum(harmonogram[[i]])
          if(sumar1 < sumar){
            sumar1=sumar
            stroj=i
          }
          stroj=sum(harmonogram[[i]])
        }
        return(stroj)
      }
      gantt<-function(harmonogram,ind,t){
        counter=1
        tcopy=t
        tasks=c(1:length(ind))
        start.date  = c(1:length(ind))
        end.date    = c(1:length(ind))
        Stroj = c(1:length(ind))
        x<-length(harmonogram)/2
        for(i in 1:x){
          y=length(harmonogram[[i]])
          start.date=0
          for(j in 1:y){
            if(j==1){
              start.date[counter]=0
              end.date[counter]=harmonogram[[i]][j]
              Stroj[counter]=i
              tasks[counter]=harmonogram[[n+i]][j]
              counter = counter + 1
            }
            else{
              start.date[counter]=end.date[counter-1]
              end.date[counter]=end.date[counter-1]+harmonogram[[i]][j]
              Stroj[counter]=i
              tasks[counter]=harmonogram[[n+i]][j]
              counter=counter+1
            }
          }
        }
        start.date=0
        for(i in 2:length(ind)){
          start.date[i]=end.date[i-1]
          if(start.date[i-1] > start.date[i]){
            start.date[i-1]=0
          }
        }
        dfg <- data.frame(
          tasks        = factor(rev(tasks), levels = rev(tasks)),
          start.date  = rev(start.date),
          end.date    = rev(end.date),
          Stroj = as.factor(rev(Stroj))
        )
        return(dfg)
      }
      dfr=  as.data.frame(gantt(harmonogram,ind,t))
      mdfr <- melt(dfr, measure.vars = c("start.date", "end.date"))
      ndfr1 <- subset(mdfr, variable == 'start.date', select=c(value))
      ndfr2 <- subset(mdfr, variable == 'end.date', select=c(value))
      gg<-ggplot(mdfr, aes(value, Stroj, colour = tasks)) +
        geom_line(size = 10) +
        geom_point(aes(value), colour = "black", shape = "line", size=13)+
        geom_text(aes(x=(ndfr1+ndfr2)/2,y=Stroj,label=tasks),colour="black")+
        ylab("Stroj") +
        xlab("Cas") +
        theme_bw()+
        scale_y_discrete()
      return(list(g=gg,type="EFT",r=r,d=d,c=dfr$end.date,data.frame=dfr))
      for(i in 1:length(ind)){
        counter=1
        edate=vector()
        pedate=vector()
        indx=vector()
        if(d[ind[dfr$tasks[i]]]>dfr$end.date[i]){
          edate[counter] =   dfr$end.date[i]
          pedate[counter] = d[dfr$tasks[i]]
          indx[counter] = dfr$tasks[i]
          counter = counter + 1
        }
      }
      if(edate){
        rbind(edate,pedate,indx)
      }
    }
    else{
      print("Vectory t a d musia mat rovnaku dlzku")
    }
  }
  else if(type == "LFT"){
    if(length(t)==length(d)){
      heur2 <- function(n,t,r,d,type)
      {
        if(type == "LFT")
        {
          m<-length(d)
          maxs=c()
          ind=c()
          for (i in 1:m){
            biggest=match(max(d), d)
            ind[i]=biggest
            maxs[i]=max(d)
            d[ind[i]]=0
          }
          return(ind)
        }
      }
      ind=heur2(n,t,r,d,"LFT")
      graf2<-function(ind,n,t)
      {
        datas2<-list()
        datas21<-list()
        for(k in 1:n)
        {
          datas2[k]=0
          datas21[k]=0
        }
        datas2[1][1]=t[ind[1]]
        for(i in 2:length(t)){
          stroj1=indexer(n, datas2)
          procesnumber=(length(datas2[[stroj1]])+1)
          if(datas2[[stroj1]][procesnumber-1]==0 )
            procesnumber=procesnumber-1
          datas2[[stroj1]][procesnumber]=t[ind[i]]
          datas21[[stroj1]][procesnumber]=ind[i]
        }
        datas21[[1]][1]=ind[1]
        datas2=append(datas2,datas21)
        return(datas2)
      }
      indexer<- function(n, datas2){
        sumar1=9999999
        sumar=sum(datas2[[1]])
        stroj=1
        for(k in 1:n){
          sumar = sum(datas2[[k]])

          if(sumar1 > sumar){
            sumar1=sumar
            stroj=k
          }
        }
        return(stroj)
      }
      harmonogram = graf2(ind,n,t)
      longestprocess<-function(harmonogram){
        sumar1=0
        stroj=1
        for(i in 1:length(harmonogram)/2){
          sumar = sum(harmonogram[[i]])
          if(sumar1 < sumar){
            sumar1=sumar
            stroj=i
          }
          stroj=sum(harmonogram[[i]])
        }
        return(stroj)
      }
      gantt<-function(harmonogram,ind,t){
        counter=1
        tcopy=t
        tasks=c(1:length(ind))
        start.date  = c(1:length(ind))
        end.date    = c(1:length(ind))
        Stroj = c(1:length(ind))
        x<-length(harmonogram)/2
        for(i in 1:x){
          y=length(harmonogram[[i]])
          start.date=0
          for(j in 1:y){
            if(j==1){
              start.date[counter]=0
              end.date[counter]=harmonogram[[i]][j]
              Stroj[counter]=i
              tasks[counter]=harmonogram[[n+i]][j]
              counter = counter + 1
            }
            else{
              start.date[counter]=end.date[counter-1]
              end.date[counter]=end.date[counter-1]+harmonogram[[i]][j]
              Stroj[counter]=i
              tasks[counter]=harmonogram[[n+i]][j]
              counter=counter+1
            }
          }
        }
        start.date=0
        for(i in 2:length(ind)){
          start.date[i]=end.date[i-1]
          if(start.date[i-1] > start.date[i]){
            start.date[i-1]=0
          }
        }
        dfg <- data.frame(
          tasks        = factor(rev(tasks), levels = rev(tasks)),
          start.date  = rev(start.date),
          end.date    = rev(end.date),
          Stroj = as.factor(rev(Stroj))
        )
        return(dfg)
      }
      dfr=  as.data.frame(gantt(harmonogram,ind,t))
      mdfr <- melt(dfr, measure.vars = c("start.date", "end.date"))
      ndfr1 <- subset(mdfr, variable == 'start.date', select=c(value))
      ndfr2 <- subset(mdfr, variable == 'end.date', select=c(value))
      gg<-ggplot(mdfr, aes(value, Stroj, colour = tasks)) +
        geom_line(size = 10) +
        geom_point(aes(value), colour = "black", shape = "line", size=13)+
        geom_text(aes(x=(ndfr1+ndfr2)/2,y=Stroj,label=tasks),colour="black")+
        ylab("Stroj") +
        xlab("Cas") +
        theme_bw()+
        scale_y_discrete()
      return(list(g=gg,type="LFT",r=r,d=d,c=dfr$end.date,data.frame=dfr))
    }
    else{
      print("Vectory t a d musia mat rovnaku dlzku")
    }
  }
}
